package cn.estsh.i3plus.ext.mes.pcn.apiservice.serviceimpl.print.strategy;

import cn.estsh.i3plus.ext.mes.pcn.apiservice.serviceimpl.print.IPrintTemplateStrategyService;
import cn.estsh.i3plus.ext.mes.pcn.pojo.context.MesProductionPsOutContext;
import cn.estsh.i3plus.pojo.mes.model.StationRequestBean;
import cn.estsh.impp.framework.boot.auth.AuthUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.HashMap;
import java.util.Map;

/**
 * @Description :
 * @Reference :
 * @Author : Castle
 * @CreateDate : 2024/6/17 16:31
 * @Modify:
 **/
@Service
@Slf4j
public class NoSortBarCodeGzStrategy implements IPrintTemplateStrategyService {
    @Override
    public Map<String, Object> execute(StationRequestBean reqBean,MesProductionPsOutContext sn, String organizeCode) {

        Map<String,Object> map = new HashMap<>();

        String partNo = sn.getPartNo();
        String partName = sn.getPartName();
        String factoryName = reqBean.getOrganizeName();
        String supplierCode = "VD501";
        int no = 1;
        String noStr = String.format("%04d", no);

        LocalDateTime now = LocalDateTime.now();
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss.SSS");
        String productDateTime = now.format(formatter);
        DateTimeFormatter dateFormatter = DateTimeFormatter.ofPattern("yyyy-MM-dd");
        String productDate = now.format(dateFormatter);
        StringBuilder barcode = new StringBuilder(partNo);
        barcode.append(partName);
        barcode.append(productDate);
        barcode.append(noStr);

        map.put("partNo", partNo);
        map.put("partName", partName);
        map.put("factoryName", factoryName);
        map.put("supplierCode", supplierCode);
        map.put("productDate", productDateTime);
        map.put("no", noStr);
        map.put("barcode", barcode.toString());
        return map;
    }
}
