package cn.estsh.i3plus.ext.mes.pcn.apiservice.serviceimpl.rulematch;

import cn.estsh.i3plus.ext.mes.pcn.api.busi.IMesNumberRuleMatchDispatchService;
import cn.estsh.i3plus.ext.mes.pcn.pojo.context.MesProductionAssemblyNosortContext;
import com.google.common.base.Objects;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.util.StringUtils;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * 正则表达式匹配
 */
@Slf4j
@Service
public class MesNumberRuleMatchCompareRangeService implements IMesNumberRuleMatchDispatchService {

    @Override
    public Boolean matchNumberRule(String organizeCode, String sn, Object... params) {
        Object obj =  params[0];
        if (obj instanceof MesProductionAssemblyNosortContext) {
            MesProductionAssemblyNosortContext context = (MesProductionAssemblyNosortContext) obj;
            if (StringUtils.isEmpty(context.getMaxValue()) ||  StringUtils.isEmpty(context.getMinValue())) {
                return false;
            }
            try {
                Double snValue = Double.parseDouble(sn);
                if (snValue > context.getMaxValue()) {
                    return false;
                }
                if (snValue < context.getMinValue()) {
                    return  false;
                }
            } catch (Exception e) {
                return false;
            }
        } else {
            return false;
        }
        return true;
    }
}
